#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include "Anthony.h"
#include "Catherine.h"

namespace {

using std::vector;

}  // namespace

int main(int argc, char **argv) {
  if (argc != 4) {
    fprintf(stderr, "Usage: ./user_program <m-to-u> <u-to-m> <shard>\n");
    exit(1);
  }
  signal(SIGPIPE, SIG_IGN);
  FILE *u_to_m = fopen(argv[2], "w");
  FILE *m_to_u = fopen(argv[1], "r");
  if (!m_to_u || !u_to_m) {
    fprintf(stderr, "Error: Failed to open the pipes.\n");
    exit(1);
  }
  const int shard = atoi(argv[3]);

  if (shard == 0) {
    // Anthony
    int N, M, A, B;
    if (fscanf(m_to_u, "%d%d%d%d", &N, &M, &A, &B) != 4) {
      fprintf(stderr, "Error: Failed to read data from manager.\n");
      exit(1);
    }
    vector<int> U(M), V(M);
    for (int i = 0; i < M; ++i) {
      if (fscanf(m_to_u, "%d%d", &U[i], &V[i]) != 2) {
        fprintf(stderr, "Error: Failed to read data from manager.\n");
        exit(1);
      }
    }
    const vector<int> x = Mark(N, M, A, B, U, V);
    if (x.size() != static_cast<size_t>(M)) {
      // Wrong Answer [1]
      fprintf(u_to_m, "1\n");
      fflush(u_to_m);
    } else {
      fprintf(u_to_m, "0\n");
      for (int i = 0; i < M; ++i) {
        fprintf(u_to_m, "%d\n", x[i]);
      }
      fflush(u_to_m);
    }
  } else if (shard == 1) {
    int flag;
    if (fscanf(m_to_u, "%d", &flag) != 1) {
      fprintf(stderr, "Error: Failed to read data from manager.\n");
      exit(1);
    }
    if (flag) {
      // Anthony fails
      exit(0);
    }
    // Catherine
    int A, B;
    if (fscanf(m_to_u, "%d%d", &A, &B) != 2) {
      fprintf(stderr, "Error: Failed to read data from manager.\n");
      exit(1);
    }
    Init(A, B);
    for (; ; ) {
      int flag;
      if (fscanf(m_to_u, "%d", &flag) != 1) {
        fprintf(stderr, "Error: Failed to read data from manager.\n");
        exit(1);
      }
      if (flag) {
        break;
      }
      vector<int> y(A);
      for (int j = 0; j < A; ++j) {
        if (fscanf(m_to_u, "%d", &y[j]) != 1) {
          fprintf(stderr, "Error: Failed to read data from manager.\n");
          exit(1);
        }
      }
      const int z = Move(y);
      fprintf(u_to_m, "%d\n", z);
      fflush(u_to_m);
    }
  } else {
    fprintf(stderr, "Error: <shard> must be 0 or 1.\n");
    exit(1);
  }
  return 0;
}
